/*
Author Local: Potter
SVN User: $Author$
File: actividades_manager
Proyect: cvisible2
Date Created: Feb 23, 2010 11:28:31 AM
Date Modified: $Date$
Description: Controla las actividades.
monoku 2010 / http://monoku.com
*/

/**********************************************
 * ACTMODEL 
 * Controlador de actividades
 * The initialization must be done in this way:
 * 		initialize(profile,selector,filters_selector,id)
 * where all the parameters are optional.
 * profile posible values:
 * 		"congresista"
 * 		"grupo"
 * 		"usuario"
 * 		"partido"
 **********************************************/
var ACTMODEL={
	/*Pagination*/
	pag:	1,		
	/*Limited number of pages*/	
	limit:	1,		
	/*Depends of the profile, some needs an ID, others doesn't*/
	id:		1,
	/*URL for activities fetching, may change per profile*/
	url:	"/actividades/usuario/",	
	/*The filter being used*/
	filter: "",
	/*The element*/
	_activities_list: $("#listado_actividades"),
	/*The element*/
	_activities_filters: $("#filtros_actividades"),
	/*Filters names*/
	buttons: {
			"Proyectos de Ley":["partido_autor_proyecto"],
			"Congresistas":["congresista_comenta","congresista_vota","ponente_de_proyecto","congresista_autor_proyecto","citante_de_citacion"],
			"Partidos":["partido_vota","partido_autor_proyecto"],
			"Comentarios":["congresista_comenta"]
		},
	/*Loads more activities*/
	more:	function(){
				if(this.limit>this.pag){
					this.pag++;
				}else{
					return false;					
				}
				this.call();
				return false;	
			},	
	/*Loads less activities*/
	less:	function(){
				if(1<this.pag){
					this.pag--;
				}else{
					return false;				
				}
				this.call();
				return false;	
			},
	/*Fetch all the activities*/
	call:	function(){
				var that=this;
				//if an id is needed
				var tempurl=this.url.replace("%id",this.id);
				var map={pagina:this.pag};
				if(this.filter!="")
					map.tipo_actividad=this.filter;
				$.post(tempurl,map,function(activities){
					that.fill(activities.elementos);
					that.limit=activities.pags;
				});
			},
	/*Fill the space with the activities*/
	fill:	function(elements){
				if(elements && elements.length){
					var doc_frag=document.createDocumentFragment();
					for ( var i = 0; i < elements.length; i++) {
						var elemento=elements[i];
						if(elemento.tipo=="cambio_estado_proyecto"){
							var $estado=$(".hidden-template li.proyecto").clone();
							$estado.find("h5 a").html(elemento.objeto_seguido.nombre).attr("href","/proyectos-de-ley/"+slugify(elemento.objeto_seguido.nombre)+"/"+elemento.objeto_seguido.id);
							$estado.find(".texto b").html(elemento.objeto_disparador.estado);
							$estado.find(".fecha").html(elemento.fecha);
							doc_frag.appendChild($estado.get(0));
						}
						else if(elemento.tipo=="congresista_comenta"){
							var $ponente=$(".hidden-template li.comento").clone();
							$ponente.find(".avatar a").attr("href","/congresistas/perfil/"+slugify(elemento.objeto_seguido.nombres+" "+elemento.objeto_seguido.apellidos)+"/"+elemento.objeto_seguido.id+"/");
							$ponente.find(".avatar img").attr("src",elemento.objeto_seguido.imagen);
							$ponente.find("h4 a").html(elemento.objeto_seguido.nombres+" "+elemento.objeto_seguido.apellidos).attr("href","/congresistas/perfil/"+slugify(elemento.objeto_seguido.nombres+" "+elemento.objeto_seguido.apellidos)+"/"+elemento.objeto_seguido.id+"/");
							$ponente.find("p.comentario").html(elemento.objeto_disparador.comment);
							$ponente.find(".fecha").html(elemento.fecha);
							doc_frag.appendChild($ponente.get(0));
						}
						else if(elemento.tipo=="congresista_vota"){ 
							var $ponente=$(".hidden-template li.votacion").clone();
							$ponente.find(".avatar a").attr("href","/congresistas/perfil/"+slugify(elemento.objeto_seguido.nombres+" "+elemento.objeto_seguido.apellidos)+"/"+elemento.objeto_seguido.id+"/");
							$ponente.find(".avatar img").attr("src",elemento.objeto_seguido.imagen);
							$ponente.find("h4 a").html(elemento.objeto_seguido.nombres+" "+elemento.objeto_seguido.apellidos).attr("href","/congresistas/perfil/"+slugify(elemento.objeto_seguido.nombres+" "+elemento.objeto_seguido.apellidos)+"/"+elemento.objeto_seguido.id+"/");
							if(elemento.objeto_disparador.voto.toLowerCase()=="si"||elemento.objeto_disparador.voto.toLowerCase()=="no"){
								$ponente.find(".valor-voto").append($("<span>").html(elemento.objeto_disparador.voto));
							}else{
								$ponente.find(".valor-voto").append($("<span>").addClass("abstencion1").html("me"))
								.append(" ")
								.append($("<span>").addClass("abstencion2").html("abstengo"));
							}
							$ponente.find(".nombre-proyecto").html("&ldquo;"+elemento.objeto_disparador.votacion.procedimiento+"&rdquo;");
							$ponente.find(".fecha").html(elemento.fecha);
							$ponente.find(".datos-alineados a").attr("href","/votaciones/"+elemento.objeto_disparador.votacion.id+"/");
							doc_frag.appendChild($ponente.get(0));
						}
						else if(elemento.tipo=="partido_vota"){ 
							var $estado=$(".hidden-template li.proyecto-votacion").clone();
							$estado.find("h4 .nombre").html("Votación del Partido "+elemento.objeto_seguido.nombre);
							$estado.find(".avatar a").attr("href","/votaciones/"+elemento.objeto_disparador.votacion.id+"/");
							//$estado.find(".avatar img").attr("src",elemento.objeto_seguido.img);
							$estado.find("h5 a").html(elemento.objeto_disparador.votacion.procedimiento).attr("href","/votaciones/"+elemento.objeto_disparador.votacion.id+"/");
							$estado.find(".texto .favor .numero").html(elemento.objeto_disparador.numero_votos_si);
							$estado.find(".texto .contra .numero").html(elemento.objeto_disparador.numero_votos_no);
							$estado.find(".fecha").html(elemento.fecha);
							doc_frag.appendChild($estado.get(0));
						}
						else if(elemento.tipo=="ponente_de_proyecto"){
							var $autor=$(".hidden-template li.ponente").clone();
							$autor.find(".avatar a").attr("href","/congresistas/perfil/"+slugify(elemento.objeto_seguido.nombres+" "+elemento.objeto_seguido.apellidos)+"/"+elemento.objeto_seguido.id+"/");
							$autor.find(".avatar img").attr("src",elemento.objeto_seguido.imagen);
							$autor.find("h4 a").html(elemento.objeto_seguido.nombres+" "+elemento.objeto_seguido.apellidos).attr("href","/congresistas/perfil/"+slugify(elemento.objeto_seguido.nombres+" "+elemento.objeto_seguido.apellidos)+"/"+elemento.objeto_seguido.id+"/");
							$autor.find("p.proyecto span").html(elemento.objeto_disparador.proyecto.nombre);
							if(elemento.objeto_disparador.estado){
								$autor.find("p.estado").html("Estado del proyecto: <b>"+elemento.objeto_disparador.estado+"</b>");
							}
							$autor.find(".fecha").html(elemento.fecha);
							$autor.find(".link-proyecto").attr("href","/proyectos-de-ley/"+slugify(elemento.objeto_disparador.proyecto.nombre)+"/"+elemento.objeto_disparador.proyecto.id);
							doc_frag.appendChild($autor.get(0));
						}
						else if(elemento.tipo=="proyecto_autor_congresista"){
							var $autor=$(".hidden-template li.autor").clone();
							$autor.find(".avatar a").attr("href","/congresistas/perfil/"+slugify(elemento.objeto_disparador.nombres+" "+elemento.objeto_disparador.apellidos)+"/"+elemento.objeto_disparador.id+"/");
							$autor.find(".avatar img").attr("src",elemento.objeto_disparador.imagen);
							$autor.find("h4 a").html(elemento.objeto_disparador.nombres+" "+elemento.objeto_disparador.apellidos).attr("href","/congresistas/perfil/"+slugify(elemento.objeto_disparador.nombres+" "+elemento.objeto_disparador.apellidos)+"/"+elemento.objeto_disparador.id+"/");
							$autor.find("p.proyecto span").html(elemento.objeto_seguido.nombre);
							$autor.find(".fecha").html(elemento.fecha);
							$autor.find(".link-proyecto").attr("href","/proyectos-de-ley/"+slugify(elemento.objeto_seguido.nombre)+"/"+elemento.objeto_seguido.id);
							doc_frag.appendChild($autor.get(0));
						}
						else if(elemento.tipo=="congresista_autor_proyecto"){
							var $autor=$(".hidden-template li.autor").clone();
							$autor.find(".avatar a").attr("href","/congresistas/perfil/"+slugify(elemento.objeto_seguido.nombres+" "+elemento.objeto_seguido.apellidos)+"/"+elemento.objeto_seguido.id+"/");
							$autor.find(".avatar img").attr("src",elemento.objeto_seguido.imagen);
							$autor.find("h4 a").html(elemento.objeto_seguido.nombres+" "+elemento.objeto_seguido.apellidos).attr("href","/congresistas/perfil/"+slugify(elemento.objeto_seguido.nombres+" "+elemento.objeto_seguido.apellidos)+"/"+elemento.objeto_seguido.id+"/");
							$autor.find("p.proyecto span").html(elemento.objeto_disparador.nombre);
							$autor.find(".fecha").html(elemento.fecha);
							$autor.find(".link-proyecto").attr("href","/proyectos-de-ley/"+slugify(elemento.objeto_disparador.nombre)+"/"+elemento.objeto_disparador.id);
							doc_frag.appendChild($autor.get(0));
						}
						else if(elemento.tipo=="citante_de_citacion"){
							var $citante=$(".hidden-template li.citacion").clone();
							$citante.find("h4 .nombre").html(elemento.objeto_seguido.nombres+" "+elemento.objeto_seguido.apellidos).attr("href","/congresistas/perfil/"+slugify(elemento.objeto_seguido.nombres+" "+elemento.objeto_seguido.apellidos)+"/"+elemento.objeto_seguido.id+"/");
							var fecha=new Date(elemento.objeto_disparador.fecha);
							$citante.find(".avatar a").attr("href","/congresistas/perfil/"+slugify(elemento.objeto_seguido.nombres+" "+elemento.objeto_seguido.apellidos)+"/"+elemento.objeto_seguido.id+"/");
							$citante.find(".avatar img").attr("src",elemento.objeto_seguido.imagen);
							$citante.find(".calendario .mes").html(parseFechaMesAno(fecha));
							$citante.find(".calendario .numero").html(parseNumeroDia(fecha));
							$citante.find(".calendario .dia").html(parseDia(fecha));
							$citante.find(".datos-alineados .tema").html(parseDia(fecha));
							$citante.find(".datos-alineados .tema").html(elemento.objeto_disparador.tema);
							var scitados="";
							if(elemento.objeto_disparador.citados){
								citados=elemento.objeto_disparador.citados;
								for ( var k = 0; k < citados.length; k++) {
									var citado=citados[k];
									scitados+=citado.nombre;
									if(k+1<citados.length){
										scitados+=", ";
									}
								}
							}
							$citante.find(".datos-alineados .invitados").html(scitados);
							$citante.find(".datos-alineados a").attr("href","/citaciones/"+slugify(elemento.objeto_disparador.tema)+"/"+elemento.objeto_disparador.id+"/");
							doc_frag.appendChild($citante.get(0));
						}
						if(elemento.tipo=="votacion_proyecto"){
							var $estado=$(".hidden-template li.proyecto-votacion").clone();
							$estado.find("h5 a").html(elemento.objeto_seguido.nombre).attr("href","/votaciones/"+slugify(elemento.objeto_seguido.nombre)+"/"+elemento.objeto_seguido.id+"/");
							$estado.find(".texto .favor .numero").html(elemento.objeto_disparador.acuerdo);
							$estado.find(".texto .contra .numero").html(elemento.objeto_disparador.desacuerdo);
							$estado.find(".fecha").html(elemento.fecha);
							if(elemento.objeto_disparador.estado=="aprobado"){
								$estado.find(".avatar img").attr("src","/media/img/voto-si.png");
							}else if(elemento.objeto_disparador.estado=="no-aprobado"){
								$estado.find(".avatar img").attr("src","/media/img/voto-no.png");
							}else{
								$estado.find(".avatar img").attr("src","/media/img/voto-neutro.png");
							}
							doc_frag.appendChild($estado.get(0));
						}
						else if(elemento.tipo=="proyecto_autor_partido"){
							var $autor=$(".hidden-template li.autor").clone();
							$autor.find(".avatar a").attr("href","/partidos/perfil/"+slugify(elemento.objeto_disparador.nombre)+"/"+elemento.objeto_disparador.id+"/");
							$autor.find(".avatar img").attr("src",elemento.objeto_disparador.img);
							$autor.find("h4 a").html(elemento.objeto_disparador.nombre).attr("href","/partidos/perfil/"+slugify(elemento.objeto_disparador.nombre)+"/"+elemento.objeto_disparador.id+"/");
							$autor.find("p.proyecto span").html(elemento.objeto_seguido.nombre);
							$autor.find(".fecha").html(elemento.fecha);
							$autor.find(".link-proyecto").attr("href","/proyectos-de-ley/"+slugify(elemento.objeto_seguido.nombre)+"/"+elemento.objeto_seguido.id);
							doc_frag.appendChild($autor.get(0));
						}
						else if(elemento.tipo=="partido_autor_proyecto"){
							var $autor=$(".hidden-template li.autor").clone();
							$autor.find(".avatar a").attr("href","/partidos/perfil/"+slugify(elemento.objeto_seguido.nombre)+"/"+elemento.objeto_seguido.id+"/");
							$autor.find(".avatar img").attr("src",elemento.objeto_seguido.img);
							$autor.find("h4 a").html(elemento.objeto_seguido.nombre).attr("href","/partidos/perfil/"+slugify(elemento.objeto_seguido.nombre)+"/"+elemento.objeto_seguido.id+"/");
							$autor.find("p.proyecto span").html(elemento.objeto_disparador.nombre);
							$autor.find(".fecha").html(elemento.fecha);
							$autor.find(".link-proyecto").attr("href","/proyectos-de-ley/"+slugify(elemento.objeto_disparador.nombre)+"/"+elemento.objeto_disparador.id);
							doc_frag.appendChild($autor.get(0));
						}
						
					}
					this._activities_list.append(doc_frag);					
				}else {
					this._activities_list.append($(".hidden-template li.empty").clone());
				}
			},
		/*All the posible profiles of data, defines the URLs and the filters to be used*/
		profiles: {
				congresista:{
					url:"/actividades/congresista/%id/",
				},
				grupo:{
					url:"/actividades/grupo/%id/",
				},
				usuario:{
					url:"/actividades/usuario/%id/",
				},
				partido:{
					url:"/actividades/partido/%id/",
				},
				proyecto:{
					url:"/actividades/proyecto-de-ley/%id/",
				}
			},
		/*Sets the profile to be used*/
		setProfile:	function(leprofile){
				this.url=this.profiles[leprofile].url;
			},
		/*Initialize the object setting the profile and defining the selectors and id*/
		initialize:	function(profile,selector,filters_selector,id){
				profile=profile||"usuario";
				this._activities_list=(selector && $(selector))||this._activities_list;
				this._activities_filters=(filters_selector && $(filters_selector))||this._activities_filters;
				this.id=id||this.id;
				this.setProfile(profile);
				this.drawFilters();
				this.call();
			},
		/*Draw the filters to be used*/
		drawFilters: function(){
				var that=this;
				this.filter="";
				this._activities_filters.empty();
				for(var attr in this.buttons){					
					var $button=$("<a href='#'><span><span>"+attr+"</span></span></a>")
					.append("<input type='hidden' value='"+attr+"'/>")
					.click(function(){
						$(this).parent().find(".active").removeClass("active");
						that.setFilter($(this).addClass("active").find("input").val());
						return false;
					});
					this._activities_filters.append($button);
				}
				//Adding Todos
				var $todos=$("<a class='active' href='#'><span><span>Todas</span></span></a>")
				.click(function(){
					$(this).parent().find(".active").removeClass("active");
					$(this).addClass("active")
					that.setFilter("");
					return false;
				});
				this._activities_filters.prepend($todos);
			},
		setFilter:	function(nufilter){
				if(nufilter!=""){
					this.filter=this.buttons[nufilter].join(",");
				}else{
					this.filter=nufilter;
				}
				this.pag=1;
				this._activities_list.empty();
				this.call();
			}
	};
