/*
Descripción: Funcionalidades javascript para la interfaz de administrador de votaciones
Archivo: admin-votaciones.js
Creado: Feb 23, 2010 11:28:31 AM
Autor: Potter
Modifico: Gabriel Roncancio Reyes
*/

/*
 Seccion 1: Carga los congresistas dinámicamente en el template del administrador, una vez se haya 
 seleccionado, la (camara o comision) y la fecha.
*/
var html_congresista_votacion=
	'<div class="inline-related">'+
		'<h3 style="display: none;"><b>Voto #@index</b>&nbsp;&nbsp;</h3>'+
		'<div class="fieldset module">'+
			'<div class="item form-cell voto ">'+
				'<select id="id_voto_set-@index-voto" name="voto_set-@index-voto">'+
				'<option value="0">Se abstuvo</option>'+
				'<option value="1">No</option>'+
				'<option value="2">Si</option>'+
				'<option value="3">No asistio</option>'+
				'<option selected="selected" value="4">No aplica</option>'+
				'<option value="5">Asistio</option>'+
				'<option value="6">Voto</option>'+
				'<option value="7">No voto</option>'+
				'<option value="8">Voto en blanco</option>'+
				'</select>'+
			'</div>'+
			'<div class="item form-cell congresista ">'+
				'<input type="text" class="vTextField ac_input" autocomplete="off" value="@nombrecongresista"><input type="text" class="cv_complete" value="@idcongresista" name="voto_set-@index-congresista" id="id_voto_set-@index-congresista" style="display: none;"><a onclick="return showAddAnotherPopup(this);" id="add_id_voto_set-@index-congresista" class="add-another" href="/admin/congreso/congresista/add/"> <img width="10" height="10" alt="Añadir otro" src="/admin/media/img/admin/icon_addlink.gif"></a>'+
			'</div>'+
			'<div class="item form-cell inline-item-tools">'+
				'<ul class="inline-item-tools">'+
				'</ul>'+
			'</div>'+
			'<input type="hidden" id="id_voto_set-@index-votacion" name="voto_set-@index-votacion">'+
			'<input type="hidden" id="id_voto_set-@index-id" name="voto_set-@index-id">'+
		'</div>'+
	'</div>'; 
var test_congresistas= new Array();
test_congresistas[0]={nombre:"congresista1",id:1};
test_congresistas[1]={nombre:"congresista2",id:2};
test_congresistas[2]={nombre:"congresista3",id:3};
test_congresistas[3]={nombre:"congresista4",id:4};
test_congresistas[4]={nombre:"congresista5",id:5};
test_congresistas[5]={nombre:"congresista6",id:6};
test_congresistas[6]={nombre:"congresista7",id:7};
var camara_elegido=false;
var comision_elegido=false;
var fecha_elegida=false;
$(function(){
	$("#id_camaras").change(function(){
		camara_elegido=($("#id_camaras option:selected").length>0);
		fechaSeleccionada();
	});
	$("#id_comisiones").change(function(){
		comision_elegido=($("#id_comisiones option:selected").length>0);
		fechaSeleccionada();
	});
	$("#calendarin0 td a").live("click",function(){
		fechaSeleccionada();
	});
	$("#calendarin0 .calendar-shortcuts a").live("click",function(){
		fechaSeleccionada();
	});
	$("#id_fecha").change(function(){
		fechaSeleccionada();
	});
});


function fechaSeleccionada() {
	if($("#id_fecha").val().length>0) {
		fecha_elegida=true;
		loadCongresistas();
	}
	else{
		fecha_elegida=false;
	}
}

function loadCongresistas() {
	if((camara_elegido || comision_elegido)&&fecha_elegida) {
		var map={camaras:'',comisiones:'',fecha:''};
		var camaras_seleccionadas=$("#id_camaras option:selected");
		for ( var i = 0; i < camaras_seleccionadas.length; i++) {
			map.camaras+=$(camaras_seleccionadas[i]).val();
			if(i<camaras_seleccionadas.length-1) {
				map.camaras+=",";
			}
		}
		var comisiones_seleccionadas=$("#id_comisiones option:selected");
		for ( var i = 0; i < comisiones_seleccionadas.length; i++) {
			map.comisiones+=$(comisiones_seleccionadas[i]).val();
			if(i<comisiones_seleccionadas.length-1) {
				map.comisiones+=",";
			}
		}
		map.fecha=$("#id_fecha").val();
		$(".inline-related").remove();
		/*$.get("/somewhere/get-congresistas",map, function(value){
			fillCongresistas(value);
		});*/
		$.get("/congresistas/admin/de-camara-comision-fecha/",map,function(data){			
			fillCongresistas(data);
		});
	}
}

function fillCongresistas(congresistas) {
	$("#id_voto_set-TOTAL_FORMS").val(congresistas.length);
	var $items_continer=$("#id_voto_set-INITIAL_FORMS").nextAll('.items');
	for ( var i = 0; i < congresistas.length; i++) {
		var nstring=html_congresista_votacion;
		nstring=nstring.replace(/@index/g, i);
		nstring=nstring.replace(/@nombrecongresista/g, congresistas[i].nombre);
		nstring=nstring.replace(/@idcongresista/g, congresistas[i].id);
		var $ncongresista=$(nstring);
		$items_continer.append($ncongresista);
	}
}

/*
 Seccion 2: Cuenta los diferentes tipos de votos (si, no, no asistio, etc.) para validar la información ingresada.
*/

$(function(){
	var inputs=$("input[type='submit']");
	for ( var i = 0; i < inputs.length; i++) {
		var $input=$(inputs[i]);
		var $newbutton=$("<input type='button'/>");
		if($input.hasClass('default')) {
			$newbutton.addClass('default');
		}
		$newbutton.attr('name',$input.attr("name"));
		$newbutton.attr('value',$input.attr("value"));
		$input.hide().parent().append($newbutton.click(function(){		
			var retorno=compararVotosConCampos();
			if(retorno) {
				$("#votacion_form").submit();
			}
		}));
	}
});

function compararVotosConCampos() {
	var vfavor=parseInt($("#id_votosFavor").val());
	var vcontra=parseInt($("#id_votosContra").val());
	var vabstinencia=parseInt($("#id_votosAbstencion").val());
	var vnoasistio=parseInt($("#id_numero_no_asistencias").val());
	var vasistio=parseInt($("#id_numero_asistencias").val());
	
	var respuesta=contarVotaciones();
	
	if(vfavor!=respuesta.si) {
		alert("No coinciden los votos a favor con los ingresados en el campo 'Número de votos a favor'. El valor ingresado es: "+vfavor+", pero el real es: "+respuesta.si);
		return false;
	}
	else if(vcontra!=respuesta.no) {
		alert("No coinciden los votos en contra con los ingresados en el campo 'Número de votos en contra'. El valor ingresado es: "+vcontra+", pero el real es: "+respuesta.no);
		return false;
	}
	else if(vabstinencia!=respuesta.seabstuvo) {
		alert("No coinciden las abstenciones con los ingresados en el campo 'Número de abstenciones'. El valor ingresado es: "+vabstinencia+", pero el real es: "+respuesta.seabstuvo);
		return false;
	}
	else if(vnoasistio!=respuesta.noasistio) {
		alert("No coinciden la cantidad de inasistencias con los ingresados en el campo 'Número de no asistencias en la votación:'. El valor ingresado es: "+vnoasistio+", pero el real es: "+respuesta.noasistio);
		return false;
	}
	else if(vasistio!=respuesta.asistio) {
		alert("No coinciden la cantidad de asistencias con los ingresados en el campo 'Número de asistencias en la votación:'. El valor ingresado es: "+vasistio+", pero el real es: "+respuesta.asistio);
		return false;
	}
	return true;
}

function contarVotaciones() {
	var i=0;
	var $votoSelect=$("#id_voto_set-"+i+"-voto");
	var respuestas= {seabstuvo:0,no:0,si:0,noasistio:0,noaplica:0,asistio:0};
	while ($votoSelect.length!=0) {
		if($votoSelect.val()==='0') {
			respuestas.seabstuvo++;
		}else if($votoSelect.val()==='1') {
			respuestas.no++;
		}else if($votoSelect.val()==='2') {
			respuestas.si++;
		}else if($votoSelect.val()==='3') {
			respuestas.noasistio++;
		}else if($votoSelect.val()==='4') {
			respuestas.noaplica++;
		}else if($votoSelect.val()==='5') {
			respuestas.asistio++;
		}
		i++;
		$votoSelect=$("#id_voto_set-"+i+"-voto");
	}
	return respuestas;
}

/*
 Seccion 3: Permite importar los datos de una votacion a partir de informacion copiada y pegada desde excel.
*/
/*
Se encarga de adicionar los campos necesarios para el proceso de importacion
*/
jQuery(document).ready(function(){
var campo_importar_votacion = '<div class="form-row importar_votacion"><div>';
campo_importar_votacion += '<p>';
campo_importar_votacion += '<input type="button" class="default" name="_importar" value="Importar" onclick="importarDatosVotacion();"> ';
campo_importar_votacion += '<input type="button" class="default" name="_reset" value="Reset" onclick="resetDatosVotacion();">';
campo_importar_votacion += '</p>';
campo_importar_votacion += '<p>';
campo_importar_votacion += '</br>';
campo_importar_votacion += '<input type="button" class="default" name="_asignar_todos" value="Asignar todos los votos a:" onclick="asignarDatosVotacion();"> ';
campo_importar_votacion += '<select name="select_asignar_todos" id="select_asignar_todos">';
campo_importar_votacion += '<option value="0">Se abstuvo</option>';
campo_importar_votacion += '<option value="1">No</option>';
campo_importar_votacion += '<option value="2">Si</option>';
campo_importar_votacion += '<option value="3">No asistio</option>';
campo_importar_votacion += '<option value="4" selected="selected">No aplica</option>';
campo_importar_votacion += '<option value="5">Asistio</option>';
campo_importar_votacion += '</select>';
campo_importar_votacion += '</p>';
campo_importar_votacion += '</div></div>';
$('fieldset').append(campo_importar_votacion);

});

/*
Importa los datos de una votacion.
*/
function importarDatosVotacion(){
    var lineas_ingresadas = $('#id_datos_importacion').val().split('\n'),
    lineas = [],
    mensaje_error_lineas = '',
    mensaje_error_duplicados = '',
    mensaje_informacion_abstenciones = '',
    mensaje_informacion_asignaciones = '',
    importaciones_exitosas = 0,
    importaciones_esperadas = 0,
    lineas_procesadas = [];
    
    // Reconocer las líneas que contienen información
    for(var i in lineas_ingresadas){
        lineas_ingresadas[i] = $.trim(lineas_ingresadas[i])
        if(lineas_ingresadas[i] != ''){
            lineas.push(lineas_ingresadas[i])
            importaciones_esperadas++;
        }
    }
    
    // Recorrer la lista de congresistas del sistema contra la lista importada
    $('div.item.form-cell.congresista').each(function(indice, congresistahtml){
        var congresista_sistema_con_formato = $(congresistahtml).find('.vTextField.ac_input').val(),
        congresista_sistema = textoAFormatoComun($(congresistahtml).find('.vTextField.ac_input').val()),
        matches = [];
        for(var i in lineas){
            var texto_linea = textoAFormatoComun(lineas[i]),
            campos = extraerCampos(texto_linea),
            congresista_importar = campos[0],
            voto_importar = campos[1],
            resultado_coincidencia = nombresSonCoincidentes(congresista_sistema, congresista_importar);            
            if(resultado_coincidencia.coincidio){
                var m = {};
                m['indice_linea']=i;
                m['linea']=lineas[i];
                m['congresista_importar']=congresista_importar;
                m['voto']=voto_importar;
                m['resultado']=resultado_coincidencia;
                matches.push(m);
            }
        }
        if(matches.length < 1){// El congresista no hizo match, voto = Se abstuvo
            mensaje_informacion_abstenciones+=congresista_sistema_con_formato + '\n';
            $(this).parent().find('div.item.form-cell.voto select').val(0);
        }else if(matches.length > 1){// El congresista hizo multiples matches, voto = No aplica 
            mensaje_error_duplicados+=congresista_sistema_con_formato+': Las líneas coincidentes son las siguientes: ';
            for(var i in matches){ mensaje_error_duplicados+='"'+matches[i].resultado.mensaje?matches[i].resultado.mensaje:matches[i].linea+'", '; }
            mensaje_error_duplicados+='\n';
            $(this).parent().find('div.item.form-cell.voto select').val(4);            
        }else{// El congresista hizo match una unica vez
            lineas_procesadas[matches[0].indice_linea] = true;
            importaciones_exitosas++;
            if(matches[0].voto == 'si') $(this).parent().find('div.item.form-cell.voto select').val(2);
            else if(matches[0].voto == 'no') $(this).parent().find('div.item.form-cell.voto select').val(1);
            else if(matches[0].voto == 'no asistio') $(this).parent().find('div.item.form-cell.voto select').val(3);
            else if(matches[0].voto == '' || matches[0].voto == 'se abstuvo') $(this).parent().find('div.item.form-cell.voto select').val(0);
            mensaje_informacion_asignaciones += importaciones_exitosas + '.\t';
            mensaje_informacion_asignaciones += 
                      matches[0].resultado.mensaje ? matches[0].resultado.mensaje:matches[0].linea;
            mensaje_informacion_asignaciones += ' -->\n\t' + congresista_sistema + '\n'; 
        }        
    });
    
    // Generar mensajes para las lineas no importadas
    for(var i in lineas){
        if(!lineas_procesadas[i]){
            mensaje_error_lineas += '"'+lineas[i]+'"\n';
        }
    }
    
    // Mostrar resultados
    var mensaje_resultado = 'La importación ha concluido con ' + importaciones_exitosas + ' importaciones exitosas '+
                            'de '+importaciones_esperadas+' líneas ingresadas. Se generaron los siguientes mensajes como resultado:\n\n';
    mensaje_resultado += !mensaje_error_lineas ? '':'Las siguientes líneas no pudieron importarse:\n'+mensaje_error_lineas+'\n';
    mensaje_resultado += !mensaje_error_duplicados ? '':'Los siguientes congresistas están presentes múltiples veces en la ' +
                         'lista importada, su voto fue marcado como "No aplica":\n' + mensaje_error_duplicados +'\n';
    mensaje_resultado += 'Las asignaciones realizadas fueron:\n' + mensaje_informacion_asignaciones +'\n';
    mensaje_resultado += !mensaje_informacion_abstenciones ? '':'Los siguientes congresistas no se encontraron en la lista'+
                         ' importada, su voto fue marcado como una abstención:\n' + mensaje_informacion_abstenciones + '\n';
    $('#id_resultados_importacion').val(mensaje_resultado);               
}

/*
Remueve caracteres con tilde, convierte a minusculas y quita multiples espacios (incluyendo tabs)
*/
function textoAFormatoComun(texto){
    texto = texto.trim().toLowerCase();
    texto = texto.replace(/á/g,'a').replace(/é/g,'e').replace(/í/g,'i');
    texto = texto.replace(/ó/g,'o').replace(/ú/g,'u').replace(/[\s\t]+/g, ' ');
    texto = texto.replace(/[\.,;:]/g,'')
    return texto;
}

/*
Indica si los nombres ingresados coinciden (para realizar este calculo se usa una 
de las heurísticas abajo indicadas).
*/
function nombresSonCoincidentes(nombre_completo, nombre_aproximado){
    return coincidenciaDifusaPalabraPorPalabra(nombre_completo, nombre_aproximado);
    //return coincidenciaDifusaSubsecuenciaComunMasLarga(nombre_completo, nombre_aproximado);
}

/*
Heurística 1:
Indica si los nombres ingresados coinciden. Para ello los compara palabra por palabra 
de manera difusa (fuzzy match usando jsdifflib.min.js), si al menos 3 palabras (o sólo 2, en 
el caso de que el nombre_aproximado sólo contenga 2 palabras) coinciden se obtiene un éxito.
*/
function coincidenciaDifusaPalabraPorPalabra(nombre_completo, nombre_aproximado){
    var palabras_nc = nombre_completo.split(' '),
    palabras_na = nombre_aproximado.split(' '),
    sm = new difflib.SequenceMatcher('', ''),
    palabras_coincidentes = 0,
    suma_score = 0,
    nombre_match = '',
    resultado = {};
    for(var i in palabras_nc){
        for(var j in palabras_na){
            if(palabras_nc[i].length > 3 && palabras_na[j].length > 3){
                sm.set_seq1(palabras_nc[i]);
                sm.set_seq2(palabras_na[j]);
                var score = sm.ratio();
                // La tolerancia se asigna con esta heuristica: 
                // En una palabra de 4 letras la subsecuencia comun mas larga debe tener al menos 3 caracteres
                if(score > 0.75){
                    nombre_match += (palabras_coincidentes == 0?'':' ') + palabras_na[j];
                    palabras_coincidentes += 1;                    
                    suma_score += score;
                    break;
                }                                
            }            
        }   
    }
    var conteo_palabras_largas = 0;
    for(var i in palabras_na) if (palabras_na[i].length > 3) conteo_palabras_largas++;
    if(palabras_coincidentes >= 3 || (conteo_palabras_largas == 2 && palabras_coincidentes == 2)){
        var score_promedio = suma_score/palabras_coincidentes;
        resultado['coincidio'] = true;
        resultado['mensaje'] = nombre_match + ' (con score: ' + score_promedio.toFixed(2);
        resultado['mensaje'] += (score_promedio >= 0.9)?'':' [score bajo, SE DEBE REVISAR!]';
        resultado['mensaje'] += ')';
    }else{
        resultado['coincidio'] = false;    
    }
    return resultado;
}

/*
Heurística 2:
Indica si los nombres ingresados coinciden. Para ello va reordenando el nombre aproximado y calcula
la longitud de la subsecuencia comun mas larga (lcs) entre la permutacion del nombre aproximado y el nombre
completo. A partir de la lcs calcula un score que se emplea para determinar si existe una coincidencia.
*/
function coincidenciaDifusaSubsecuenciaComunMasLarga(nombre_completo, nombre_aproximado){
    var palabras_aproximado = nombre_aproximado.split(' '),
    nombre_aprox_reordenado,
    resultado = {},
    max_score = 0,
    nombre_max_score;
    
    for(var i = 0; i < palabras_aproximado.length; i++){
        nombre_aprox_reordenado= '';
        for(var j = 0; j < palabras_aproximado.length; j++){
            nombre_aprox_reordenado += ((j == 0) ? '':' ') + 
                                            palabras_aproximado[ (i+j) % palabras_aproximado.length ];
        }
        var lcs = longestCommonSubsequence(nombre_completo, nombre_aprox_reordenado),
        score = lcs/nombre_aprox_reordenado.length;
        if(score > max_score){
            max_score = score;
            nombre_max_score = nombre_aprox_reordenado;
        }
    }
    if(max_score > 0.9){
        resultado['coincidio'] = true;
        resultado['mensaje'] = nombre_max_score + ' con score: ' + max_score.toFixed(2);
    }else if(max_score > 0.75){
        resultado['coincidio'] = true;
        resultado['mensaje'] = nombre_max_score + ' con score: ' + max_score.toFixed(2) + ' (score bajo, SE DEBE REVISAR!)';
    }else{
        resultado['coincidio'] = false;
    }
    return resultado;
}

/*
Calcula la longitud de la subsecuencia comun mas larga entre dos cadenas
*/
function longestCommonSubsequence(a, b){
    var lcs = [];
    for(var i = 0; i < a.length; i++){
        lcs[i] = [];
        for(var j = 0; j <  b.length; j++){
            if(a.charAt(i) == b.charAt(j)){
                if(i == 0 || j == 0) lcs[i][j] = 1;
                else lcs[i][j] = lcs[i-1][j-1] + 1;
            }else{
                if(i == 0 && j == 0) lcs[i][j] = 0;
                else if(i == 0) lcs[i][j] = lcs[i][j-1];
                else if(j == 0) lcs[i][j] = lcs[i-1][j];
                else lcs[i][j] = Math.max(lcs[i-1][j], lcs[i][j-1]);
            }
        }
    }
    return lcs[a.length-1][b.length-1];
}

/*
Extrae los campos (el nombre y el voto) de la línea ingresada
*/
function extraerCampos(texto_linea){
    var sm = new difflib.SequenceMatcher('', ''),
    campos = [];    
    if(texto_linea.substr(-3) == ' si'){
        campos[0] = texto_linea.substr(0, texto_linea.length-3);
        campos[1] = 'si';
    }else if(texto_linea.substr(-3) == ' no'){
        campos[0] = texto_linea.substr(0, texto_linea.length-3);
        campos[1] = 'no';
    }else {
        sm.set_seq1($.trim(texto_linea.substr(-11)));
        sm.set_seq2('no asistio');
        if(sm.ratio() > 0.81) // se admiten maximo dos errores (9/11=0.8181)
        {
            campos[0] = texto_linea.substr(0, texto_linea.length-11);
            campos[1] = 'no asistio';   
        }else {
            sm.set_seq1($.trim(texto_linea.substr(-11)));
            sm.set_seq2('se abstuvo');
            if(sm.ratio() > 0.81) // se admiten maximo dos errores (9/11=0.8181)
            {
                campos[0] = texto_linea.substr(0, texto_linea.length-11);
                campos[1] = 'se abstuvo';
            }else{
                campos[0] = texto_linea;
                campos[1] = '';   
            }
        }
    }
    return campos;
}

/*
Reinicia los datos de la votacion
*/
function resetDatosVotacion(){
    $('div.item.form-cell.voto select').val(4);
    $('#id_resultados_importacion').val('');
}

/*
Asigna automaticamente todos los votos a un solo valor dado por un select
*/
function asignarDatosVotacion(){
    $('div.item.form-cell.voto select').val($('#select_asignar_todos').val());
}
