/**
Codigo javascript para la pagina del perfil de comision. 
Especificamente se incluye la logica para los botones "Ver Mas"
de las pestanias EN TRAMITE, QUE PASARON (pasados) y VOTACIONES, y para
los botones de deslizamiento de la pestania INTEGRANTES.
Ademas incluye la logica necesaria para administrar el calendario de 
la pestania AGENDA. La logica restante podria ser revisada en perfil.js 
y perfil-partido.js
*/

var sentido=1;
var date_selected=undefined;
var hoy=new Date();
hoy.setHours(0, 0, 0, 0);

$(document).ready(function(){
    $(".boton-ver-mas.en_tramite a").click(function(){mostrarProyectosEnTramite();return false;});
    $(".boton-ver-mas.pasados a").click(function(){mostrarProyectosPasados();return false;});
    $(".boton-ver-mas.votaciones a").click(function(){mostrarVotaciones();return false;});
    
	var elementos=$(".list-comision li");
	$(".list-comision li h4 a").live("click", function(event){
		event.stopPropagation();
		return true;
	});
	$(".list-comision li").live("click", function(){
		$(this).toggleClass("open");
	});
	
	$("#calendario a.prev").click(function(){
		anterioresFechas();
		return false;
	});
	
	$("#calendario a.next").click(function(){
		siguientesFechas();
		return false;
	});
	$("#datepicker-continer").datepicker({
		onSelect: function(dateText, inst) {
			$("#datepicker-continer").slideUp();
			var date=$(this).datepicker('getDate');
			siguientesFechas(date.getTime());
		},
		changeMonth: true,
		changeYear: true
	});
	$('body').click(function(event) {
		$("#datepicker-continer").slideUp();
	});
	$("#thedatepicker").click(function(event){
		$("#datepicker-continer").slideDown();
		event.stopPropagation();
	});
	$("#datepicker-continer").click(function(event){
		event.stopPropagation();
	});
	$("#calendario li").live("click", function(){
		$("#calendario li").not($(this).addClass("selected")).removeClass("selected");
		setFechaOrdenDelDia(new Date(parseFloat($(this).find("input").val())));
	});
	$("#botones-filtros a").click(function(){
		if(!$(this).hasClass("selected")) {
			$("#botones-filtros a").not($(this).addClass("selected")).removeClass("selected");
			setFiltroActividades($(this).find("span span").html());
		}
		return false;
	});
	
	/* El evento para el cual se adiciona un handler es un custom event (i.e. no es generado 
	por javascript), dicho evento es generado en la logica del tab en media/js/perfil.js */
	$(".tab.orden-del-dia").bind("tabdisplayed",function(){
	    anterioresFechas( hoy, cargarUltimaFecha);
	});	
});

function mostrarProyectosEnTramite(){
	$(".listado_actividades.en_tramite li.display-none").fadeIn();
	$('.boton-ver-mas.en_tramite a').unbind('click');
	$('.boton-ver-mas.en_tramite a').click(function(){ocultarProyectosEnTramite(); return false;})
}
function ocultarProyectosEnTramite(){
	$(".listado_actividades.en_tramite li.display-none").fadeOut();
	$('.boton-ver-mas.en_tramite a').unbind('click');
	$('.boton-ver-mas.en_tramite a').click(function(){mostrarProyectosEnTramite(); return false;})
}
function mostrarProyectosPasados(){
	$(".listado_actividades.pasados li.display-none").fadeIn();
	$('.boton-ver-mas.pasados a').unbind('click');
	$('.boton-ver-mas.pasados a').click(function(){ocultarProyectosPasados(); return false;})
}
function ocultarProyectosPasados(){
	$(".listado_actividades.pasados li.display-none").fadeOut();
	$('.boton-ver-mas.pasados a').unbind('click');
	$('.boton-ver-mas.pasados a').click(function(){mostrarProyectosPasados(); return false;})
}
function mostrarVotaciones(){
	$("table.fancy-table.tabla-votos tr.display-none").fadeIn();
	$('.boton-ver-mas.votaciones a').unbind('click');
	$('.boton-ver-mas.votaciones a').click(function(){ocultarVotaciones(); return false;})
}
function ocultarVotaciones(){
	$("table.fancy-table.tabla-votos tr.display-none").fadeOut();
	$('.boton-ver-mas.votaciones a').unbind('click');
	$('.boton-ver-mas.votaciones a').click(function(){mostrarVotaciones(); return false;})
}

/* El siguiente código ha sido tomado de media/js/perfil-partido.js */
function siguienteListadoCongresistas(element){
	var $container=$(element).parent().prev();
	if($container.find(".listadosimple").length<=1){
		return false;
	}
	if($container.find(".listadosimple:animated").length==0){
		$container.height($container.height());
		$container.find(".listadosimple").css("position","absolute");
		var $siguiente=$container.find(".activo").next().length==0?$container.find(".listadosimple:first"):$container.find(".activo").next();
		$siguiente.width($siguiente.parent().width()).css("left",$siguiente.parent().width());
		$container.find(".activo").width($siguiente.parent().width());
		$container.find(".activo").animate({left:"-"+$siguiente.parent().width()+"px"},"slow", function(){
			$container.find(".activo").not($siguiente).removeClass("activo");
			$container.find(".listadosimple").css("position","relative");
			$container.height("auto");
		});
		$siguiente.addClass("activo");
		$siguiente.animate({left:0},"slow");
	}
	return false;
}
function anteriorListadoCongresistas(element){
	var $container=$(element).parent().prev();
	if($container.find(".listadosimple").length<=1){
		return false;
	}
	if($container.find(".listadosimple:animated").length==0){
		$container.height($container.height());
		$container.find(".listadosimple").css("position","absolute");
		var $anterior=$container.find(".activo").prev().length==0?$container.find(".listadosimple:last"):$container.find(".activo").prev();
		$anterior.width($anterior.parent().width()).css("left",-$anterior.parent().width());
		$container.find(".activo").width($anterior.parent().width());
		$container.find(".activo").animate({left:$anterior.parent().width()+"px"},"slow", function(){
			$container.find(".activo").not($anterior).removeClass("activo");
			$container.find(".listadosimple").css("position","relative");
			$container.height("auto");
		});
		$anterior.addClass("activo");
		$anterior.animate({left:0},"slow");
	}
	return false;
}
/* END El siguiente código ha sido tomado de media/js/perfil-partido.js */

/* El siguiente código ha sido tomado de media/js/orden-del-dia.js */
/**
 * Carga las fechas anteriores a la primera de la lista
 * @param valor
 * @return true
 */
function anterioresFechas(valor, callback) {
	callback=callback||function(){};
	$("#calendario ul").animate({left:($("#calendario ul").position().left+$("#calendario").width())},function(){
		$("#calendario li.selected").removeClass("selected");
		sentido=-1;
		if(valor) {
			getFechasOrdenesDelDia(valor, callback);
		}else {
			var fecha=$("#calendario ul li:visible input:first").val();
			getFechasOrdenesDelDia(fecha, callback);
		}
	});
	return true
}

/**
 * Carga las fechas siguientes a la última de la lista
 * @param valor
 * @return true
 */
function siguientesFechas(valor, callback) {
	callback=callback||function(){};
	$("#calendario ul").animate({left:($("#calendario ul").position().left-$("#calendario").width())},function(){
		$("#calendario li.selected").removeClass("selected");
		sentido=1;
		if(valor) {
			getFechasOrdenesDelDia(valor, callback);
		}else {
			var fecha=$("#calendario ul li:visible input:last").val();
			getFechasOrdenesDelDia(fecha, callback);
		}
	});
	return true
}

/**
 * Hace el llamado ajax para cargar las fechas de ordenes del día
 * @param fecha
 * @return true
 */
function getFechasOrdenesDelDia(fecha, callback) {
	callback=callback||function(){};
	var temp=(sentido==1?"":"-")
	//alert("URL: /orden-del-dia/listar-fechas/"+temp+parseInt(fecha/1000)+"/6/")
	var comision_id = $('#comision_id').val()
	$.get("/orden-del-dia/listar-fechas/"+temp+parseInt(fecha/1000)+"/6/"+comision_id+"/",function (data){
		setFechasOrdenesDelDia(data, fecha);
		callback();
	});
	$("#calendario,#calendario a").css("cursor","wait");
	return true
}
/**
 * Refresca el listado de fechas dado el modelo
 * @param fechas
 * @return true
 */
function setFechasOrdenesDelDia(fechas) {
	if(fechas.length==0) {
	 return true;
	}
	$("#calendario").css("cursor","auto");
	$("#calendario a").css("cursor","pointer");
	var calendarios=$("#calendario ul li").hide();
	for ( var i = 0; i < fechas.length; i++) {
		if($(calendarios[i]).hasClass("hoy")) {
			$(calendarios[i]).removeClass("hoy");
		}
		var fechatemp=new Date(fechas[i].fecha*1000);
		fechatemp.setHours(0, 0, 0, 0);

		$(calendarios[i]).find(".mes").html(parseFechaMes(fechatemp));
		$(calendarios[i]).find(".dia").html(fechas[i].dia);
		$(calendarios[i]).find(".nombre").html(parseDia(fechatemp));
		$(calendarios[i]).find("input").val(fechatemp.getTime());
		if(hoy.getTime()==fechatemp.getTime()) {
			$(calendarios[i]).addClass("hoy");
		}
		if(fechatemp.getTime()==date_selected) {
			$(calendarios[i]).addClass("selected");
		}
		$(calendarios[i]).show();
	}
	if(sentido>0) {
		$("#calendario ul").css("left",$("#calendario").width());
		$("#calendario ul").animate({left:42});
	}
	else{
		$("#calendario ul").css("left",-$("#calendario").width());
		$("#calendario ul").animate({left:42});
	}
	return true
}

/**
 * Al elegir una fecha del listado, se carga dicho orden del dia
 * @param fecha
 * @return true
 */
function setFechaOrdenDelDia(fecha){
	fecha.setHours(0, 0, 0, 0);
	date_selected=fecha.getTime();
	//Se asigna la fecha al titulo, si es hoy se habilita el tag hoy
	$(".fecha-de-busqueda .texto").html(parseFechaLegible(fecha));
	if(fecha.getTime()==hoy.getTime()){
		$(".fecha-de-busqueda .tag").show();
	}else {
		$(".fecha-de-busqueda .tag").hide();
	}
	//Ahora se asigna la busqueda
	loadOrdenDelDia(fecha);
	return true;
}

/**
 * Cuando un filtro es seleccionado se ocultan los resultados que no coincidan (solo html)
 * @param actividad
 * @return true
 */
function setFiltroActividades(actividad) {
	if(actividad=="Todo") {
		$("#resultados li").show();
	}else if(actividad=="Citaciones"){
		$("#resultados li .actividad .tag span span:not(:contains('Citaci'))").parents("li").hide();
		$("#resultados li .actividad .tag span span:contains('Citaci')").parents("li").show();
	}else if(actividad=="Proyectos"){
		$("#resultados li .actividad .tag span span:not(:contains('Proyecto'))").parents("li").hide();
		$("#resultados li .actividad .tag span span:contains('Proyecto')").parents("li").show();
	}else{
		$("#resultados li .actividad .tag span span:contains('Citaci'),#resultados li .actividad .tag span span:contains('Proyecto')").parents("li").hide();
		$("#resultados li .actividad .tag span span").not(":contains('Citaci'),:contains('Proyecto')").parents("li").show();
	}
	return true;
}

/**Description: Orden del Dia de Congreso Visible
Version: 1.0
Author: http://www.monoku.com
 * Realiza el llamado ajax para cargar el orden del dia dada una fecha en long
 * @param fecha
 * @return true
 */
function loadOrdenDelDia(fecha){
	$("#resultados").html("cargando...").css("cursor","wait");
	var comision_id = $('#comision_id').val()
	$.get("/orden-del-dia/"+parseInt(fecha.getTime()/1000)+"/"+comision_id+"/",function (data){
		cargarOrdenDelDia(data);
	});
	return true;
}

/**
 * Carga la informacion del json al html
 */
function cargarOrdenDelDia(data) {
	if(data.length==0) {
	 return true;
	}

	$("#botones-filtros a").removeClass("selected").first().addClass('selected');
	var $resultados=$("#resultados");
	$resultados.html("").css("cursor","auto");
	$("#lista-comisiones").html("");
	$("#list_cat_genero").html("Todos");
	$("#lista-comisiones").append($("<li>").html("Todos").attr("val","Todos"));
	for ( var i = 0; i < data.length; i++) {
		var doc_frag=document.createDocumentFragment();
		elem_comision=data[i];
		if(elem_comision.comision||elem_comision.camara){			
			$resultados.append($("<h3>").html((elem_comision.comision||"Plenaria de "+elem_comision.camara)));
		}else{
			$resultados.append($("<h3>").html("Otro"));
		}
		$resultados.append($("<ul>").addClass("list-comision"));
		var actividades=elem_comision.actividades;
		if(actividades){
			for ( var j = 0; j < actividades.length; j++) {
				var actividad=actividades[j];
				var $template;
				if(actividad.tipo.toLowerCase().indexOf("citac")!=-1) {
					$template=$("#template .elem-citacion").clone();
					$template.find(".e_titulo").html("<span style='font-size:120%'>"+actividad.tipo_citacion+":</span> "+actividad.titulo).attr("href","/citaciones/"+slugify(actividad.titulo)+"/"+actividad.id_citacion);
					$template.find(".e_tema").html(actividad.tema);
					$template.find(".e_citantes").html("");
					if(actividad.citantes){						
						for ( var k = 0; k < actividad.citantes.length; k++) {
							var citante=actividad.citantes[k];
							$template.find(".e_citantes").append($("<a>").html(citante.nombre).attr("href","/congresistas/perfil/"+slugify(citante.nombre)+"/"+citante.id+"/"));
							if(k<actividad.citantes.length-1&&actividad.citantes.length>1) {
								$template.find(".e_citantes").append(",&nbsp;");
							}
						}
					}
					var $ecitado=$template.find(".citado").clone();
					$template.find(".e_citados").html("");
					if(actividad.citados){						
						for ( var k = 0; k < actividad.citados.length; k++) {
							var citado=actividad.citados[k];
							$ecitado=$ecitado.clone();
							//$ecitado.find(".titulo").html(citado.cargo);
							$ecitado.find(".nombre").html(citado.nombre);
							//.append($("<span>").addClass("cargo").html(citado.donde));
							$template.find(".e_citados").append($ecitado);
						}
					}
				}
				else if(actividad.tipo.toLowerCase().indexOf("proyecto")!=-1) {
					$template=$("#template .elem-proyecto").clone();
					$template.find(".e_titulo").html(actividad.titulo).attr("href","/proyectos-de-ley/"+slugify(actividad.proyecto.nombre)+"/"+actividad.proyecto.id);
					$template.find(".e_proyecto").html(actividad.proyecto.nombre);
					$template.find(".e_proyecto_link").attr("href","/proyectos-de-ley/"+slugify(actividad.proyecto.nombre)+"/"+actividad.proyecto.id);
					$template.find(".e_estado").html(actividad.datos.estado?actividad.datos.estado:"&minus;");
					$template.find(".e_numero_camara").html(actividad.datos.numero_camara?actividad.datos.numero_camara:"&minus;");
					$template.find(".e_numero_senado").html(actividad.datos.numero_senado?actividad.datos.numero_senado:"&minus;");
				}else{
					$template=$("#template .elem-otro").clone();
					$template.find(".e_titulo").html(actividad.titulo).attr("href","#"+slugify(actividad.titulo)).click(function(){return false;});
				}
				if(!actividad.importante) {
					$template.find(".alert").hide();
				}
				doc_frag.appendChild($template.addClass("open").get(0));
			}
			$("#resultados ul:last").append(doc_frag);
		}
		if(elem_comision.camara||elem_comision.comision){
			if($("#lista-comisiones li[val='"+(elem_comision.camara||"Plenaria de "+elem_comision.comision)+"']").length==0){				
				$("#lista-comisiones").append($("<li>").html((elem_comision.comision||"Plenaria de "+elem_comision.camara)).attr("val",(elem_comision.comision||"Plenaria de "+elem_comision.camara)));
				
			}
		}
	}
}
 
function cargarUltimaFecha(){
	$("#calendario li").removeClass("selected");
	$("#calendario li:visible:last").addClass("selected");
	//alert("cargando ultima fecha: "  + new Date(parseFloat($("#calendario li:visible:last input").val())))
	setFechaOrdenDelDia(new Date(parseFloat($("#calendario li:visible:last input").val())));
}
/* END - El siguiente código ha sido tomado de media/js/orden-del-dia.js */
